#!/usr/bin/php
<?
chdir(dirname(__FILE__));
require_once('../nmail/include/global.php');
require_once("include/mail_lib.php");
require_once("include/admin_lib.php");
require_once("include/file.php");


// 웹상에서의 실행방지.
if ($_SERVER['DOCUMENT_ROOT'] || $_SERVER['SERVER_SOFTWARE'])
{
	die("Access Denied");	
}	// if()


echo "[Nmail] 메일서버의 계정 상태와 DB 계정 상태 동기화 작업.\n\n";
echo "-. 웹메일 회원관리를 거치지 않고 다음처럼 nmail_member 테이블에서 데이타를 직접 변경한 경우, 이 스크립트를 실행하면 메일서버에 즉시 반영됩니다.\n";
echo "  1. 계정 레벨인 m_level 필드를 [".$G['LEVEL']['out']."]로 변경하여, [".$G['LEVEL_NAME'][$G['LEVEL']['out']]."]으로 처리한 경우.\n";
echo "  2. 휴면계정 지정기간인 m_suspend_start, m_suspend_end 필드를 변경하여, 휴면계정으로 사용을 제한한 경우.\n";
echo "  3. 사용기간 지정기간인 m_use_start, m_use_end 필드를 변경하여, 사용기간을 제한한 경우.\n\n";


// [2007-04-03] 중복실행방지
	$pname = basename(__FILE__);
	$pname2 = preg_replace('/\.php$/i', "", $pname);

	$pid = $pname2.'.pid';
	// 파일이 있을 경우 먼저 실행중인 스크립트가 존재하는지 확인함.
	if (file_exists($pid))
	{
		list($pid_old) = file($pid);
		if (is_numeric($pid_old))
		{
			ob_start();
			system('ps -fp '.$pid_old);
			$ps = ob_get_contents();
			ob_end_clean();
			if (strpos($ps, $pname) !== false)
			{
				echo "\n[경고]동기화 작업이 이미 진행중이므로 중단합니다.\n\n";
				echo $ps;
				echo "\n";
				exit;
			}	// if()
		}	// if()
	}	// if()

	// pid
	$fh=fopen($pname2.'.pid',"w"); 
	fwrite($fh,getmypid()); 
	fclose($fh);


// set
set_time_limit(0);
ini_set('memory_limit', '512M');
$memory_limit = ini_get('memory_limit');
#echo "memory_get_usage: ".number_format(memory_get_usage()) . "\n"; 

$_start = getmicrotime();

// 입력값 확인.
$d_name_input = addslashes($_SERVER['argv'][1]);
$m_id_input = addslashes($_SERVER['argv'][2]);
#if (!$d_name_input || !$m_id_input)
if (!$d_name_input)
{
	die("  사용방법)\n    - 특정 회  원 : ".$_SERVER['PHP_SELF']." domain.com userid\n    - 특정 도메인 : ".$_SERVER['PHP_SELF']." domain.com\n    - 전체 도메인 : ".$_SERVER['PHP_SELF']." ALL\n");
}	// if()


if ($d_name_input == 'ALL')
{
	$dm = db_get_rows("SELECT d_no, d_name FROM " . $TB['DOMAIN'] . "");
} else 
{
	$d_no = db_get_one("SELECT d_no FROM " . $TB['DOMAIN'] . " WHERE d_name = '" . $d_name_input . "'");
	if (!$d_no)
		die("존재하지 않는 도메인입니다.\n=> " . $d_name_input."\n");

	$q_where = '';
	if ($m_id_input)
	{
		$q_where = " m_id = '" . $m_id_input . "' AND ";
	}	// if()

	$dm = array(array('d_no'=>$d_no, 'd_name'=>$d_name_input));
}	// if()

for ($di=0; $di<sizeof($dm); $di++)
{

	$d_no = $dm[$di]['d_no'];
	$d_name = $dm[$di]['d_name'];

	// [2007-07-21] 메일링 리스트 계정은 제외
	//$mbr = db_get_rows("SELECT m_no, m_id, m_mail_file_group FROM " . $TB['MEMBER'] . " WHERE ".$q_where." d_no = '" . $d_no . "'");
	$mbr = db_get_rows("SELECT * FROM " . $TB['MEMBER'] . " WHERE ".$q_where." d_no = '" . $d_no . "' AND m_usertype IS NULL");
	$mbr_cnt = sizeof($mbr);
	if ($mbr_cnt < 1)
	{
		if ($m_id_input)
		{
			die("존재하지 않는 사용자입니다.\n=> " . $m_id_input."\n");
		} else if ($d_name_input != 'ALL')
		{
			die("도메인내에 등록된 사용자가 없습니다.\n");
		}	// if()
	} else 
	{
		echo "[".$d_name."] ".number_format($mbr_cnt)."명의 동기화 작업을 시작합니다.\n";

		for ($mi=0; $mi<$mbr_cnt; $mi++)
		{
			// [2006-08-08] 사용자 상태 갱신
			mbr_stats_update($mbr[$mi]['m_no']);

			// view
			if (($mi > 0 && ($mi+1)%100 == 0) || ($mi+1) == $mbr_cnt)
			{
				echo "... " . number_format($mi+1) . "명 ( " . round(getmicrotime() - $_start) . "sec )\n";
				flush();
			} else if ($mi%10 == 0)
			{
				echo ".";
				flush();
			}	// if()

			if ($mi%10 == 0)
				usleep(100000);

			#echo "[".$d_name."][".$mbr[$mi]['m_id']."]update (" . round((getmicrotime() - $_start),4) . "sec)\n";
		}	// for()

		#echo "[".$d_name."] ".number_format($mbr_cnt)."명의 동기화 작업이 완료되었습니다. (" . round((getmicrotime() - $_start),4) . "sec)\n";
		#echo "[" . round((getmicrotime() - $_start),4) . "sec]동기화 작업이 완료되었습니다.\n";
	}	// if()
}	// for()


// [2007-04-03] 중복실행방지
unlink($pid);

echo "[" . round((getmicrotime() - $_start),4) . "sec]모든 동기화 작업이 완료되었습니다.\n";

if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
{
	system('pause');
}	// if()

#require_once('include/global_end.php');
?>